## est-2ed-5-5-source.zip

=== myinterface/Makefile ===
# $Revision: 11 $
# $Date: 2010-12-21 14:53:47 +0100 (tor, 21 dec 2010) $

# Linux instalation
install:
	$(MKDIR) $(DESTDIR)/lib/myinterface
	$(CP) -d $(BINDIR)/mi.tcl $(DESTDIR)/lib/myinterface
	$(CP) -d $(BINDIR)/miDialog.tcl $(DESTDIR)/lib/myinterface
	$(CP) -d $(BINDIR)/pkgIndex.tcl $(DESTDIR)/lib/myinterface

# -----------------------------------------------------------------------
# purge = purify source directory, clean = purify bin directory

purge:
	$(RM) *~

clean:
