=== est-2ed/projects/demo/Makefile ===
RM = rm -f
OS = `uname | sed "s/_.*//;s/[0-9]//g"`

all: start demo

static: start stat_demo

start:
	@echo "Project demo"
	@echo OS = $(OS)
	@echo Looking for Makefile.$(OS) ...
	@echo

demo:
	@$(MAKE) -f Makefile.$(OS)

stat_demo:
	@$(MAKE) static -f Makefile.$(OS)

purge:
	@$(RM) *~

clean:
	@$(RM) *.o
	@$(RM) *.out
	@$(RM) *.gcov
	@$(RM) *.gcda
	@$(RM) *.gcno
	@$(RM) *.bb
	@$(RM) *.bbg
	@$(RM) *.da
	@$(RM) biddy.dll
	@$(RM) libbiddy.dylib
	@$(RM) est2.dll
	@$(RM) libest2.dylib
	@$(RM) demo
	@$(RM) demo.exe
