=== est-2ed/projects/min/Makefile ===
RM = rm -f
OS = `uname | sed "s/_.*//;s/[0-9]//g"`

all: start min

static: start stat_min

start:
	@echo "Project min"
	@echo OS = $(OS)
	@echo Looking for Makefile.$(OS) ...
	@echo

min:
	@$(MAKE) -f Makefile.$(OS)

stat_min:
	@$(MAKE) static -f Makefile.$(OS)

purge:
	$(RM) *~

clean:
	@$(RM) *.o
	@$(RM) *.out
	@$(RM) *.gcov
	@$(RM) *.gcda
	@$(RM) *.gcno
	@$(RM) *.bb
	@$(RM) *.bbg
	@$(RM) *.da
	@$(RM) biddy.dll
	@$(RM) libbiddy.dylib
	@$(RM) est2.dll
	@$(RM) libest2.dylib
	@$(RM) min
	@$(RM) min.exe
