=== est-2ed/projects/wca/Makefile ===
RM = rm -f
OS = `uname | sed "s/_.*//;s/[0-9]//g"`

all: start wca

static: start stat_wca

start:
	@echo "Project wca"
	@echo OS = $(OS)
	@echo Looking for Makefile.$(OS) ...
	@echo

wca:
	@$(MAKE) -f Makefile.$(OS)

stat_wca:
	@$(MAKE) static -f Makefile.$(OS)

purge:
	$(RM) *~

clean:
	@$(RM) *.o
	@$(RM) *.out
	@$(RM) *.gcov
	@$(RM) *.gcda
	@$(RM) *.gcno
	@$(RM) *.bb
	@$(RM) *.bbg
	@$(RM) *.da
	@$(RM) biddy.dll
	@$(RM) libbiddy.dylib
	@$(RM) est2.dll
	@$(RM) libest2.dylib
	@$(RM) wca
	@$(RM) wca.exe
