=== est-2ed/source/ccs/Makefile ===
#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 76 $]
#  Date        [$Date: 2013-04-26 14:26:09 +0200 (pet, 26 apr 2013) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2013
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

RM = rm -f
CP = cp
MKDIR = mkdir -p
CD = cd

ECHO = echo
DATE = date -R
LS = perl -e 'print localtime((stat($$ARGV[0]))[9]) . " $$ARGV[0]\n";'
LINECMD = sed -e 's/\(...\) \(...\) \(..\) \(.*\) \(.*\) \(.*\)/\* \3 \2 \5 \4 \6/'

all: nop
mish: bindir about start ccs ok
lib: bindir header $(BINDIR)/ccsMain.o $(BINDIR)/ccs.tab.o $(BINDIR)/verilog.tab.o

# -----------------------------------------------------------------------
# testing

local: mish
	@$(CP) ccsDialog.tcl $(BINDIR)

# -----------------------------------------------------------------------
# help

nop:
	@echo Please, use \"make -f Makefile.xxx\", where xxx is your OS.

start:
	@echo "-------------------------------"
	@echo "| Building CCS package ... |"
	@echo "-------------------------------"

ok:
	@echo "----------------------------------------"
	@echo "| CCS package successfully compiled |"
	@echo "----------------------------------------"

# -----------------------------------------------------------------------
# create a directory for binary files

bindir:
	@$(MKDIR) $(BINDIR)

# -----------------------------------------------------------------------
# create information about the package

about:
	@$(ECHO) "Builded on \c" > $(BINDIR)/ccs.about
	@$(DATE) >> $(BINDIR)/ccs.about
	@$(LS) ccs.h | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsInt.h | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsMain.c | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsParser.l | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsParser.y | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsVerilog.l | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsVerilog.y | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsTcl.c | $(LINECMD) >> $(BINDIR)/ccs.about
	@$(LS) ccsDialog.tcl | $(LINECMD) >> $(BINDIR)/ccs.about

# -----------------------------------------------------------------------
# copy header file

header:
	@$(CP) ccs.h $(BINDIR)

# -----------------------------------------------------------------------
# make objects
# -----------------------------------------------------------------------

$(BINDIR)/ccsMain.o: ccsMain.c ccs.h ccsInt.h
	$(CC) -o $(BINDIR)/ccsMain.o -c ccsMain.c

$(BINDIR)/ccs.tab.o: ccsParser.l ccsParser.y ccs.h ccsInt.h
	$(FLEX) -Pccs -t ccsParser.l > $(BINDIR)/lex.ccs.c
	$(BISON) -p ccs -b $(BINDIR)/ccs -v ccsParser.y
	$(CC) -I. -I$(BINDIR) -o $(BINDIR)/ccs.tab.o -c $(BINDIR)/ccs.tab.c

$(BINDIR)/verilog.tab.o: ccsVerilog.l ccsVerilog.y ccs.h ccsInt.h
	$(FLEX) -Pverilog -t ccsVerilog.l > $(BINDIR)/lex.verilog.c
	$(BISON) -p verilog -b $(BINDIR)/verilog -v ccsVerilog.y
	$(CC) -I. -I$(BINDIR) -o $(BINDIR)/verilog.tab.o -c $(BINDIR)/verilog.tab.c

# -----------------------------------------------------------------------
# make tcl extension
# -----------------------------------------------------------------------

$(BINDIR)/ccsTcl.o: ccsTcl.c ccs.h ccsInt.h ccsStubInit.c ccsStubLib.c
	$(CC) -o $(BINDIR)/ccsTcl.o -c ccsTcl.c -D'USECONST=$(USECONST)'
	$(CC) -o $(BINDIR)/ccsStubInit.o -c ccsStubInit.c
	$(CC) -o $(BINDIR)/ccsStubLib.o -c ccsStubLib.c

ccs: $(BINDIR)/ccsMain.o $(BINDIR)/ccs.tab.o $(BINDIR)/verilog.tab.o $(BINDIR)/ccsTcl.o
	$(CD) $(BINDIR); $(LN) \
		ccsTcl.o \
		ccsMain.o \
		ccs.tab.o \
		verilog.tab.o \
		ccsStubInit.o \
		$(ESTLIB) $(PTHREADLIB) $(TCLLIB)
	$(CD) $(BINDIR); $(AR) libccsstub.a ccsStubLib.o

# -----------------------------------------------------------------------
# purge = purify source directory, clean = purify bin directory

purge:
	@$(RM) *~

clean:
	@$(RM) $(BINDIR)/ccs.tab.c
	@$(RM) $(BINDIR)/lex.ccs.c
	@$(RM) $(BINDIR)/ccs.output
	@$(RM) $(BINDIR)/verilog.tab.c
	@$(RM) $(BINDIR)/lex.verilog.c
	@$(RM) $(BINDIR)/verilog.output
	@$(RM) $(BINDIR)/ccsMain.o
	@$(RM) $(BINDIR)/ccs.tab.o
	@$(RM) $(BINDIR)/verilog.tab.o
	@$(RM) $(BINDIR)/ccsTcl.o
	@$(RM) $(BINDIR)/ccsStubInit.o
	@$(RM) $(BINDIR)/ccsStubLib.o
	@$(RM) $(BINDIR)/libccsstub.a
	@$(RM) $(BINDIR)/ccsMain.bb
	@$(RM) $(BINDIR)/ccsMain.bbg
	@$(RM) $(BINDIR)/ccsMain.da
	@$(RM) $(BINDIR)/ccsTcl.bb
	@$(RM) $(BINDIR)/ccsTcl.bbg
	@$(RM) $(BINDIR)/ccsTcl.da
	@$(RM) $(BINDIR)/ccs.tab.bb
	@$(RM) $(BINDIR)/ccs.tab.bbg
	@$(RM) $(BINDIR)/ccs.tab.da
	@$(RM) $(BINDIR)/verilog.tab.bb
	@$(RM) $(BINDIR)/verilog.tab.bbg
	@$(RM) $(BINDIR)/verilog.tab.da
