=== est-2ed/source/pa/Makefile ===
#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 76 $]
#  Date        [$Date: 2013-04-26 14:26:09 +0200 (pet, 26 apr 2013) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2013
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

RM = rm -f
CP = cp
MKDIR = mkdir -p
CD = cd

ECHO = echo
DATE = date -R
LS = perl -e 'print localtime((stat($$ARGV[0]))[9]) . " $$ARGV[0]\n";'
LINECMD = sed -e 's/\(...\) \(...\) \(..\) \(.*\) \(.*\) \(.*\)/\* \3 \2 \5 \4 \6/'

all: nop
mish: bindir about start pa ok
lib: bindir header $(BINDIR)/paMain.o $(BINDIR)/paKod.o $(BINDIR)/paOutput.o $(BINDIR)/pa.tab.o

# -----------------------------------------------------------------------
# testing

local: mish
	@$(CP) paDialog.tcl $(BINDIR)

# -----------------------------------------------------------------------
# help

nop:
	@echo Please, use \"make -f Makefile.xxx\", where xxx is your OS.

start:
	@echo "----------------------------------------"
	@echo "| Building Process algebra package ... |"
	@echo "----------------------------------------"

ok:
	@echo "-------------------------------------------------"
	@echo "| Process algebra package successfully compiled |"
	@echo "-------------------------------------------------"

# -----------------------------------------------------------------------
# create a directory for binary files

bindir:
	@$(MKDIR) $(BINDIR)

# -----------------------------------------------------------------------
# create information about the package

about:
	@$(ECHO) "Builded on \c" > $(BINDIR)/pa.about
	@$(DATE) >> $(BINDIR)/pa.about
	@$(LS) pa.h | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paInt.h | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paMain.c | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paKod.c | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paOutput.c | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paParser.l | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paParser.y | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paTcl.c | $(LINECMD) >> $(BINDIR)/pa.about
	@$(LS) paDialog.tcl | $(LINECMD) >> $(BINDIR)/pa.about

# -----------------------------------------------------------------------
# copy header file

header:
	@$(CP) pa.h $(BINDIR)

# -----------------------------------------------------------------------
# make objects
# -----------------------------------------------------------------------

$(BINDIR)/paMain.o: paMain.c pa.h paInt.h
	$(CC) -o $(BINDIR)/paMain.o -c paMain.c

$(BINDIR)/paKod.o: paKod.c pa.h paInt.h
	$(CC) -o $(BINDIR)/paKod.o -c paKod.c

$(BINDIR)/paOutput.o: paOutput.c pa.h paInt.h
	$(CC) -o $(BINDIR)/paOutput.o -c paOutput.c

$(BINDIR)/pa.tab.o: paParser.l paParser.y pa.h paInt.h
	$(FLEX) -Ppa -t paParser.l > $(BINDIR)/lex.pa.c
	$(BISON) -p pa -b $(BINDIR)/pa -v paParser.y
	$(CC) -I. -I$(BINDIR) -o $(BINDIR)/pa.tab.o -c $(BINDIR)/pa.tab.c

# -----------------------------------------------------------------------
# make tcl extension
# -----------------------------------------------------------------------

$(BINDIR)/paTcl.o: paTcl.c pa.h paInt.h paStubInit.c paStubLib.c
	$(CC) -o $(BINDIR)/paTcl.o -c paTcl.c -D'USECONST=$(USECONST)'
	$(CC) -o $(BINDIR)/paStubInit.o -c paStubInit.c
	$(CC) -o $(BINDIR)/paStubLib.o -c paStubLib.c

pa: $(BINDIR)/paMain.o $(BINDIR)/paKod.o $(BINDIR)/paOutput.o $(BINDIR)/pa.tab.o $(BINDIR)/paTcl.o
	$(CD) $(BINDIR); $(LN) \
		paTcl.o \
		paMain.o \
		paKod.o \
		paOutput.o \
		pa.tab.o \
		paStubInit.o \
		$(ESTLIB) $(PTHREADLIB) $(TCLLIB)
	$(CD) $(BINDIR); $(AR) libpastub.a paStubLib.o

# -----------------------------------------------------------------------
# purge = purify source directory, clean = purify bin directory

purge:
	@$(RM) *~

clean:
	@$(RM) $(BINDIR)/lex.pa.c
	@$(RM) $(BINDIR)/pa.tab.c
	@$(RM) $(BINDIR)/pa.output
	@$(RM) $(BINDIR)/paMain.o
	@$(RM) $(BINDIR)/paKod.o
	@$(RM) $(BINDIR)/paOutput.o
	@$(RM) $(BINDIR)/pa.tab.o
	@$(RM) $(BINDIR)/paTcl.o
	@$(RM) $(BINDIR)/paStubInit.o
	@$(RM) $(BINDIR)/paStubLib.o
	@$(RM) $(BINDIR)/libpastub.a
	@$(RM) $(BINDIR)/paMain.bb
	@$(RM) $(BINDIR)/paMain.bbg
	@$(RM) $(BINDIR)/paMain.da
	@$(RM) $(BINDIR)/paTcl.bb
	@$(RM) $(BINDIR)/paTcl.bbg
	@$(RM) $(BINDIR)/paTcl.da
	@$(RM) $(BINDIR)/paKod.bb
	@$(RM) $(BINDIR)/paKod.bbg
	@$(RM) $(BINDIR)/paKod.da
	@$(RM) $(BINDIR)/paOutput.bb
	@$(RM) $(BINDIR)/paOutput.bbg
	@$(RM) $(BINDIR)/paOutput.da
	@$(RM) $(BINDIR)/pa.tab.bb
	@$(RM) $(BINDIR)/pa.tab.bbg
	@$(RM) $(BINDIR)/pa.tab.da
