=== est-2ed/debian/control ===
Source: est2ed
Section: math
Priority: extra
Maintainer: Robert Meolic <meolic@uni-mb.si>
Build-Depends: debhelper (>= 8.0.0), bison, flex, tcl-dev, tk-dev, libbiddy1-dev (>= 1.1)
Standards-Version: 3.9.3

Package: est2ed
Section: math
Architecture: any
Depends: tcl, tk, libbiddy1 (>= 1.1), ${shlibs:Depends}, ${misc:Depends}
Description: Efficient Symbolic Tools 2nd Edition
 http://lms.uni-mb.si/EST/
 EST is a tool for the formal verification of systems.
 EST is a collection of algorithms based on binary decision diagrams (BDDs).
 Currently, it supports only our own BDD package called Biddy, but one day
 it could support other BDD packages, too.
 This package includes simple Tcl/Tk GUI called My Interface.
