=== est-2ed/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Changed by Robert Meolic (meolic@uni-mb.si).

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# Add here commands to configure the package.
configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

# Add here commands to compile the package.
build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) mish "BINDIR=`pwd`/bin"
	$(MAKE) milocal "BINDIR=`pwd`/bin"
	touch $@

# Add here commands to clean up after the build process.
clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(MAKE) clean "BINDIR=`pwd`/bin"
	dh_clean

# Add here commands to install the package into debian/package/usr
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) -f Makefile.Linux DESTDIR=$(CURDIR)/debian/est2ed/usr install "BINDIR=`pwd`/bin"

# Build architecture-independent files here.
# We have nothing to do by default.
binary-indep: build install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
#	dh_shlibdeps -l /home/meolic/est/biddy/bin --dpkg-shlibdeps-params=--ignore-missing-info
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
